﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : BasePage
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    /// <summary>
    /// 重写数据绑定，必须重写这个方法
    /// </summary>
    protected override void GridView_DataBind()
    {
        // 准备数据
        List<PersonInfo> list = new List<PersonInfo>();

        // 分页大小
        VirtualPagerGridView1.PageSize = 10;

        // AllowCacheDatatSource 默认为true，适用于将全部数据一次性绑定到GridView，在分页的过程中数据源不会发生变化。
        // 如果不允许缓存DataSource，则每次页码变化时都调用GridView_DataBind，每次获取数据重新绑定，数据源的实时性更强。
        // VirtualPagerGridView1.AllowCacheDatatSource = false;

        // 如果允许自定义分页，则每次获取指定页的数据
        // 同时不能缓存DataSource，即AllowCacheDatatSource=false
        // VirtualPagerGridView1.AllowCustomPaging = true;
        // VirtualPagerGridView1.VirtualRecordCount = 45;

        if (VirtualPagerGridView1.AllowCustomPaging)
        {
            list = GetPageData(VirtualPagerGridView1.PageIndex, VirtualPagerGridView1.PageSize);
        }
        else
        {
            list = GetAllData();
        }

        //绑定数据到GridView
        VirtualPagerGridView1.DataSource = list;
        VirtualPagerGridView1.DataBind();
    }

    /// <summary>
    /// 一次性获取全部数据
    /// </summary>
    /// <returns></returns>
    private static List<PersonInfo> GetAllData()
    {
        List<PersonInfo> list = new List<PersonInfo>();
        for (int i = 1; i <= 45; i++)
        {
            PersonInfo person = new PersonInfo();
            person.Id = i;
            person.Name = "张三" + i;

            if (i % 2 == 0)
            {
                person.Gender = "男";
            }
            else
            {
                person.Gender = "女";
            }

            list.Add(person);
        }
        return list;
    }

    /// <summary>
    /// 获取指定页的数据
    /// </summary>
    /// <returns></returns>
    private static List<PersonInfo> GetPageData(int pageIndex, int pageSize)
    {
        List<PersonInfo> list = new List<PersonInfo>();
        for (int i = pageIndex * pageSize + 1; i <= pageIndex * pageSize + pageSize && i <= 45; i++)
        {
            PersonInfo person = new PersonInfo();
            person.Id = i;
            person.Name = "张三" + i;

            if (i % 2 == 0)
            {
                person.Gender = "男";
            }
            else
            {
                person.Gender = "女";
            }

            list.Add(person);
        }
        return list;
    }
}